﻿using System;
using Keyoti.SearchEngine.Events;
using Keyoti.SearchEngine.Documents;
using Keyoti.SearchEngine.DataAccess;

namespace Keyoti.SearchEngine
{
    /// <summary>
    /// Test class for event handling.
    /// </summary>
    public class ExternalEventHandler
    {


        IEventDispatcher dispatcher;
        Configuration conf;
        public ExternalEventHandler(IEventDispatcher dispatcher, Configuration conf)
        {
            Keyoti.SearchEngine.DataAccess.Log.WriteLogEntry("PageBooster_Plugin", "SUCCESS", conf);
            dispatcher.Action += new ActionEventHandler(dispatcher_Action);
            dispatcher.NeedObject += new NeedObjectEventHandler(dispatcher_NeedObject);
            this.dispatcher = dispatcher;
            this.conf = conf;
        }


        public void DetachHandlers()
        {
            if (dispatcher != null)
            {
                dispatcher.Action -= new ActionEventHandler(dispatcher_Action);
                dispatcher.NeedObject -= new NeedObjectEventHandler(dispatcher_NeedObject);
            }

        }


        public void dispatcher_Action(object sender, ActionEventArgs e)
        {
            Keyoti.SearchEngine.DataAccess.Log.WriteLogEntry("PageBooster_Plugin", e.ActionData.Name.ToString(), conf);
            if (e.ActionData.Name == ActionName.ReadText)
            {

                int boost = Convert.ToInt32((e.ActionData.Data as DocumentText).MetaCustomData);
                WordCollection words = (e.ActionData.Data as DocumentText).Words;
                foreach (Word word in words)
                {
                    word.Weight *= boost;
                }

            }
           

        }

        public void dispatcher_NeedObject(object sender, NeedObjectEventArgs e)
        {
            

        }
    }
}
